% The Neon Rust/Node.js Bridge

Neon is a Rust bridge to the [Node.js](http://nodejs.org) platform: an
API (and a set of tools) for implementing binary Node modules in
Rust. Neon makes it possible to write **fast**, **portable**, and
**parallel** modules with [Rust](http://www.rust-lang.org): a language
that makes systems programming safe and fun!

**_Getting Started_**

**[Neon Guide](./guide.html):** an introduction to Neon that will
get you up and running quickly.


**_Documentation_**

**[Neon API Documentation](neon/index.html):** comprehensive
documentation for the Neon API.


**_Contributing_**

**[Hacking on Neon](./hacking.html):** a guide to the internals of
Neon.
